<?php

if (empty($_GET['test']))
  header("Content-type: image/png");

function gauss($x) {
  global $mean, $stdev;
  $dev=$x-$mean;
  $exp1=.5*(-pow($dev,2)/pow($stdev,2));
  $exp=exp($exp1);
  $y=($exp/($stdev*2.5066));
  return $y;
}

function process() {
  global $mean, $stdev, $numpoints, $points;
  $sigma=0;
  for ($i=0; $i<$numpoints; $i++)
    $mean+=$points[$i];
  $mean/=$numpoints;
  for ($i=0; $i<$numpoints; $i++)
    $sigma+=pow(($points[$i]-$mean),2);
  $stdev=sqrt($sigma/$numpoints);
}

$im    = imagecreatefrompng("graph.png");
$black = imagecolorallocate($im, 0, 0, 0);

$points=explode(":",$_GET['data']);
$numpoints=count($points);
sort($points);
$ulthigh=end($points);
$mean=0;
$stdev=0;

process();
while((end($points)-$mean)>(2*$stdev)) {
	$numpoints--;
  array_pop($points);
  process();
}
$numpoints=count($points);
$low=$points[0]; $high=$points[0];
for ($i=0; $i<$numpoints; $i++) {
  if ($points[$i]<$low) $low=$points[$i];
  if ($points[$i]>$high) $high=$points[$i];
}

$spread=$high-$low;
$Xscale=245/$spread;
$meanheight=gauss($mean);
$Yscale=120/$meanheight;
for ($i=0; $i<$numpoints; $i++) { // draw x-axis lines for actual data points
  $x=round((($points[$i]-$low)*$Xscale)+45);
  imageline($im, $x, 200, $x, 205, $black);
}
for ($i=45; $i<291; $i++) { // draw graph
  $x=$i;
  $value=(($i-45)/$Xscale)+$low;
  $y=round(gauss($value)*$Yscale);
  $y=200-$y;
  imagesetpixel($im, $x, $y, $black);
}
$stdevYL=200-round(gauss($mean-$stdev)*$Yscale);
$stdevYH=200-round(gauss($mean+$stdev)*$Yscale);
$stdevXL=round(((($mean-$stdev)-$low)*$Xscale))+45;
$stdevXH=round(((($mean+$stdev)-$low)*$Xscale))+45;

$x=round((($mean-$low)*$Xscale)+45);
imagestring($im, 9, $stdevXL-10, 215, round($mean-$stdev,1), $black);
imagestring($im, 9, $stdevXH-10, 215, round($mean+$stdev,1), $black);
imagestring($im, 9, $x-10, 215, round($mean,1), $black);
imagestring($im, 9, 45, 235, "Stdev= ".round($stdev,1), $black);
imagestring($im, 9, 200, 235, "Low: ".$low, $black);
imagestring($im, 9, 200, 255, "High: ".$ulthigh, $black);
imageline($im, $x, 200, $x, 215, $black);
imagedashedline($im, $stdevXL, $stdevYL, $stdevXL, 200, $black);
imagedashedline($im, $stdevXH, $stdevYH, $stdevXH, 200, $black);
imagepng($im); // output to browser
imagedestroy($im); // free memory
?> 